// Images.js by Feek //

//-------------------//
// Created: 04/06/07 //
// Updated: 08/06/07 //
//-------------------//

//---===Slide Image===---//

function SlideImage(img)
{
	this.img = img;
}

// This is used to place an image //
SlideImage.prototype.slideFrom = function(x,y)
{
	this.x = x;
	this.y = y;
	this.xv = x;
	this.yv = y;
}

// This is used to set the images area to slide towards //
SlideImage.prototype.slideTo = function(newX,newY)
{
	this.newX = newX;
	this.newY = newY;
}

// This is used to slide the image over time //
SlideImage.prototype.slide = function(msecs)
{
	var bg = GrabImage(x,y,w,h);
	var time = GetTime();
	while (time + msecs > GetTime())
	{
		bg.blit(x,y);
		with (this)
		{
			img.blit(xv,yv);
			if (newX > x) xv = x + (GetTime() - time) * (newX-x) / msecs;
			if (newX < x) xv = x - (GetTime() - time) * (x-newX) / msecs;
			if (newY > y) yv = y + (GetTime() - time) * (newY-y) / msecs;
			if (newY < y) yv = y - (GetTime() - time) * (y-newY) / msecs;
			FlipScreen();
		}
	}
}

//---===Animation===---//

function Animation()
{
	this.frames = [];
}

Animation.prototype.addFrame = function(img)
{
	this.frames.push(img);
}

Animation.prototype.play = function(type,ax,ay)
{
	var bg = GrabImage(x,y,w,h);
	for (var i = 0; i < this.frames.length; ++i)
	{
		bg.blit(x,y);
		if (type == "center")
		{
			this.frames[i].blit(x+w/2-this.frames[i].width/2+ax,y+h/2-this.frames[i].height/2+ay);
		}
		FlipScreen();
		Delay(320);
	}
}