// Main Pokemon script by Feek //

//-------------------//
// Created: 04/06/07 //
// Updated: 17/06/07 //
//-------------------//

// Require System Scripts //
RequireSystemScript('screen.js');
RequireSystemScript('audio.js');
RequireSystemScript('time.js');

// Require My Scripts //
RequireScript('LoadStuff.js');
RequireScript('Movement.js');
RequireScript('Data.js')
RequireScript('Images.js');
RequireScript('PokeMenu.js');
RequireScript('Pokedex.js');
RequireScript('TextWindow.js');
RequireScript('Battle.js');
RequireScript('PokeNaming.js');
RequireScript('Players.js');
RequireScript('Teleport.js');
RequireScript('Stats.js');
RequireScript('Map.js');

// Require My Resources //
RequireScript('MyMenus.js');
RequireScript('Dialogue.js');
RequireScript('PokemonDescriptions.js');
RequireScript('Pokemon.js');

// Main function //
function game()
{
	LoadStuff();
	ChangeMusic('Title.mid');
	Clear();
	CenterText("Created by",-8);
	CenterText("Feek 2007");
	FadeFromColor(2000,White);
	Clear();
	CenterText("Created by",-8);
	CenterText("Feek 2007");
	FadeToColor(2000,White);	
	title.blit(x,y);
	FadeFromColor(4000,White);
	while(!IsKeyPressed(KEY_ENTER))
	{
		title.blit(x,y);
	}
	ClearKeys();
	Clear();
	startMenu.run(x,y);
}

function StartGame()
{
	CreatePerson("you","Main.rss",false);
	ClearKeys();
	AttachInput("you");
	AttachCamera("you");
	ChangeMusic('Pallet Town.mid');
	SetTalkActivationKey(KEY_CTRL);
	// clear the unwanted directions
	Pokemon[16].clone(Player.pokemon);
	SetLevel(Player.pokemon[0],2);
	Pokemon[19].clone(Player.pokemon);
	SetLevel(Player.pokemon[1],2);
	BindKey(KEY_UP,'','');
	BindKey(KEY_DOWN,'','');
	BindKey(KEY_LEFT,'','');
	BindKey(KEY_RIGHT,'','');
	SetUpdateScript('Gameplay()');
	MapEngine("Pallet Inside.rmp",60);
}

function Gameplay()
{
	Movement(16);
	JumpChecker();
	if (IsKeyPressed(KEY_ENTER)) {ClearKeys(); gameMenu.run(x+w-80,y);}
}

// Other prime functions related to the game //
function CenterText(txt,y_offset)
{
	if (y_offset == undefined) y_offset = 0;
	font.drawText(x+w/2-font.getStringWidth(txt)/2,y+h/2+y_offset,txt);
}

function ClearKeys()
{
	while(AreKeysLeft())
	{
		GetKey();
	}
}

function Clear()
{
	Rectangle(x,y,x+w,y+h,White);
}