// Tile Movement By Feek.
// Updated For Tile Obstructions,

//-------------------//
// Created: 00/00/06 //
// Updated: 09/06/07 //
//-------------------//

//--------------------------------------------------
// Only problem is the collision detection
// being off a bit while frantically moving around
// mainly due to the GetPersonSpeedX(or)Y functions.
//--------------------------------------------------
// (It does work, but the script looks
// like fliks tile movement script...)

var g_move_allow    = 0;                 
var g_able_move     = -1;                
var g_tile_movement = true;    
var north           = COMMAND_MOVE_NORTH;
var south           = COMMAND_MOVE_SOUTH;
var west            = COMMAND_MOVE_WEST; 
var east            = COMMAND_MOVE_EAST; 
var wait            = COMMAND_WAIT;      
var face_north      = COMMAND_FACE_NORTH;
var face_south      = COMMAND_FACE_SOUTH;
var face_east       = COMMAND_FACE_EAST;
var face_west       = COMMAND_FACE_WEST;

function SetPersonFace(name,direction)
{
	SetPersonDirection(name,direction);
	UpdateMapEngine();
}

function Movement(amount)
{
	var delta_x = 0;
	var delta_y = 0;
	var player = GetInputPerson();
	
	//---= Set Commands =---//
	if (IsKeyPressed(KEY_UP))
	{
		delta_y = g_tile_movement ? (amount / GetPersonSpeedY(player)) : GetPersonSpeedY(player);
		delta_y *= -1;
		command = north;
		face = face_north;
		QueuePersonCommand(player,face,true);
		g_move_allow=1;
	}
	if (IsKeyPressed(KEY_DOWN))
	{
		delta_y = g_tile_movement ? (amount / GetPersonSpeedY(player)) : GetPersonSpeedY(player);
		command = south;
		face = face_south;
		QueuePersonCommand(player,face,true);
		g_move_allow=1;
	}
	if (IsKeyPressed(KEY_RIGHT))
	{
		delta_x = g_tile_movement ? (amount / GetPersonSpeedX(player)) : GetPersonSpeedX(player);
		command = east;
		face = face_east;
		QueuePersonCommand(player,face,true);
		g_move_allow=1;
	}
	if (IsKeyPressed(KEY_LEFT))
	{
		delta_x = g_tile_movement ? (amount / GetPersonSpeedX(player)) : GetPersonSpeedX(player);
		delta_x *= -1;
		command = west;
		face = face_west;
		QueuePersonCommand(player,face,true);
		g_move_allow=1;
	}
	
	//---= Stop Person =---//
	if(!IsPersonObstructed(player,GetPersonX(player) + delta_x,GetPersonY(player) + delta_y))
	{
		g_able_move = Math.max(Math.abs(delta_x), Math.abs(delta_y));
	}
	
	//---= Do Commands =---//
	if (g_move_allow == 1 && g_able_move > 0)
	{
		for (var j = 0; j < amount; ++j)
		{
			QueuePersonCommand(player,command,false);
			FrameDelay(4);
		}
		g_move_allow=0;
		if (!temp_teleport) temp_teleport = true;
		if (!IsAnyKeyPressed())
		{
			SetPersonFrame(player,0);
			UpdateMapEngine();
		}
	}
}

// needed to delay the frame and animate the map //

function FrameDelay(timems)//useful for animations to be drawn
{                          // at the same map fps.
	var time = GetTime();
	SetFrameRate(GetMapEngineFrameRate());// set fps to that of the map engine
	while (GetTime() < time+timems)       // update and draw.
	{
		UpdateMapEngine();
		RenderMap();
		FlipScreen();
	}
	SetFrameRate(0);                      // set back to normal fps.
}

// Event specific functions //

function PlayerDirection()
{
	return GetPersonDirection(GetInputPerson());
}

function SetDirection(name,direction)
{
	SetPersonDirection(name,direction)
}

function SetUpPerson(name,x,y,direction)
{
	SetPersonX(name,x);
	SetPersonY(name,y);
	SetPersonDirection(name,direction);
	UpdateMapEngine();
}

function FacePlayer(name)
{
	if (name == undefined) name = GetCurrentPerson();
	if (PlayerDirection() == "north") SetDirection(name,"south");
	if (PlayerDirection() == "south") SetDirection(name,"north");
	if (PlayerDirection() == "east") SetDirection(name,"west");
	if (PlayerDirection() == "west") SetDirection(name,"east");
}

// For NPC's in general
// Self Explanatory:
function DoesPersonExist(name)
{
	var list = GetPersonList();
	for (var i = 0; i < list.length; ++i)
	{
		if (list[i] == name) return true;
	}
	return false;
}

function Move(name,tiles,command,face)
{
	if (name == undefined) name = GetCurrentPerson();
	if (face == undefined)
	{
		if (command == north) face = "north"; 
		if (command == south) face = "south"; 
		if (command == east) face = "east"; 
		if (command == west) face = "west"; 
	}
	if (command != wait) SetPersonDirection(name,face);
	for (var j = 0; j < tiles; ++j)
	{
		for (var i = 0; i < 16; ++i)
		{
			QueuePersonCommand(name,command,false);
		}
		SetPersonFrame(name,0);
	}
}

// A more Advanced Random Walk function:
////////////////////////////////////////////
// x and y set up the up-right corner of
// the area to walk whilist the w and h
// set up the lower left pixel of the area
//to walk in.
////////////////////////////////////////////

var RandomWalking = [];
for (var i = 0; i < 10; ++i)
{
	RandomWalking.push(RandomWalk);
}

function RandomWalk(name)
{
	if (DoesPersonExist(name) == true)
	{
		var p_x = GetPersonX(name), p_y = GetPersonY(name);
		var tiles = 1;
		var commands = [north,south,east,west,wait];
		var command_number = Math.floor(Math.random()*commands.length);
		if (commands[command_number] == wait) tiles = 3;
		Move(name,tiles,commands[command_number]);
	}
}

// Jumping function for ledges.

// To get the tile in front of the player.
function GetTileInFront()
{
	var direction = GetPersonDirection("you");
	var px = GetPersonX("you"), py = GetPersonY("you");
	if (direction == "north") return GetTile(px/16,py/16-1,0);
	if (direction == "south") return GetTile(px/16,py/16+1,0);
	if (direction == "west") return GetTile(px/16-1,py/16,0);
	if (direction == "east") return GetTile(px/16+1,py/16,0);
}

// The jumping function:
function JumpChecker()
{
	var direction = GetPersonDirection("you");
	var tile = GetTileInFront();
	if (GetTileName(tile) == "jump" && direction == "south")
	{
		CreatePerson("s","Shadow.rss",true);
		SetPersonX("s",GetPersonX("you"));
		SetPersonY("s",GetPersonY("you"));
		UpdateMapEngine();
		IgnoreTileObstructions("s",true);
		IgnoreTileObstructions("you",true);
		IgnorePersonObstructions("you",true);
		for (var i = 0; i < 32; ++i)
		{
			QueuePersonCommand("you",south,false);
			SetPersonFrame("you",1);
			FrameDelay(2);
		}
		IgnoreTileObstructions("you",false);
		IgnorePersonObstructions("you",false);
		SetPersonFrame("you",1);
		UpdateMapEngine();
		DestroyPerson("s");
	}
}