// PokeMenu.js by Feek //

//-------------------//
// Created: 05/06/07 //
// Updated: 14/06/07 //
//-------------------//

// This will create the Pokemon Menu //
function PokeMenu()
{
	this.items = [];
	this.fade = false;
}

// This will append items to the menu //
PokeMenu.prototype.addItem = function(name,callback)
{
	var item = new Object;
	item.name = name;
	item.callback = callback;
	this.items.push(item);
}

// This will append items to the start of the menu //
PokeMenu.prototype.unshiftItem = function(name,callback)
{
	var item = new Object;
	item.name = name;
	item.callback = callback;
	this.items.unshift(item);
}

// This will call the menu and run it //
PokeMenu.prototype.run = function(wx,wy)
{
	wx+=8; // to include the windows border //
	wy+=8; // to include the windows border //
	var ci = 0; // current item //
	var bg = GrabImage(x,y,w,h);
	var menu = true;
	while(menu)
	{
		if (IsMapEngineRunning()) RenderMap();
		else bg.blit(x,y);
		with (this)
		{
			win.drawWindow(wx,wy,64,items.length*16);
			menu_arrow.blit(wx,wy+8+ci*16);
			for (var i = 0; i < items.length; ++i)
			{
				font.drawText(wx+8,8+wy+i*16,items[i].name);
			}
			FlipScreen();
			
			// -- Keyboard support -- //
			while(AreKeysLeft())
			{
				switch(GetKey())
				{
					case KEY_UP:
						if (ci > 0) --ci;
					break;
					case KEY_DOWN:
						if (ci < items.length -1) ++ci;
					break;
					case KEY_CTRL:
						if (this.fade)
						{
							if (IsMapEngineRunning()) RenderMap();
							else Clear();
							win.drawWindow(wx,wy,64,this.items.length*16);
							for (var i = 0; i < this.items.length; ++i)
							{
								font.drawText(wx+8,8+wy+i*16,this.items[i].name);
							}
						}
						items[ci].callback();
						return;
					break;
					case KEY_SHIFT:
						if (IsMapEngineRunning()) menu = false;
					break;
				}
			}
		}
	}
	Delay(150);
}